;-------------- Definition when using GCC on a i386 architecture --------------

(provide 'gcc-i386)
(require 'gcc)
(require 'endian)

;------ What *you* can configure ------
;Define this if you're sure nobody'll ever wanna run your binary on a 386:

(define *ASSUME-486* #f)


;------ Various Sizes ------

"We are little-endian"		(define *BYTE-ORDER* *LITTLE-ENDIAN*)
"We can use half words"		(define *HAS-HALFWORD*)
"We can use 64 bit words"	(define *HAS-UINT64*)
"We can use 32 bit words"	(define *HAS-UINT32*)
"We can use 16 bit words"	(define *HAS-UINT16*)
"We can use 8 bit words"	(define *HAS-UINT8*)
"We can access unaligned data"	(define *HAS-UNALIGNED-ACCESS*)


(C:typedef	"unsigned char"		'uint8)
(C:typedef	"signed char"		'int8)
(C:typedef	"unsigned short"	'uint16)
(C:typedef	"signed short"		'int16)
(C:typedef	"unsigned long"		'uint32)
(C:typedef	"signed long"		'int32)
(C:typedef	"unsigned long long"	'uint64)
(C:typedef	"signed long long"	'int64)

(C:typedef	'uint8			'Byte)
(C:typedef	'uint16			'HalfWord)
(C:typedef	'uint32			'Word)


;------ Inline assembly... ------

"
In inline asm statements, i386-specific constraints are:
`a'	EAX
`b'	EBX
`c'	ECX
`d'	EDX
`S'	ESI
`D'	EDI
`B'	EBP

else see *C Extensions:: section in gcc.info* files.
"



;--- Byte swapping


;__inline__ static uint32 swap_4_bytes(uint32 x)
;	asm(
;	    ifdef({__ASSUME_486__},{
;		"bswap %0"     /* use bswap instruction */
;	    },{
;		"xchgb %b0,%h0\n\t"     /* swap lower bytes     */
;		"rorl $ 16,%0\n\t"       /* swap low and high words */
;		"xchgb %b0,%h0"         /* swap ex-higher now-lower bytes */
;	    })
;	  :"=q" (x)
;	  : "0" (x));
;	return x;
;__inline__ static uint16 swap_2_bytes(uint16 x)
;	asm(
;		"xchgb %b0,%h0\n\t"     /* swap lower bytes     */
;	  :"=q" (x)
;	  : "0" (x));
;	return x;
;
;})
