(provide 'libc)

;------------------------------------------------------------------------------
;----------------------------- Small C library --------------------------------
;------------------------------------------------------------------------------



;---------------------- Provide defaults for some constructs ------------------

(define C:inline "")


;------------------------------ Basic Types -----------------------------------

(C:typedef	'(C:type* C:void)	'ptr-t)

;------------------------ Memory access routines ------------------------------


(define (DefineXXAccess T)
   (let ((put-T (C:->symbol 'put- T))
	 (get-T (C:->symbol 'get- T)))
   (C:define-func put-T
	'C:void
	'((x ptr-t) (y T))
	'(C:set! (C:* (type-cast (C:type* T) x)) y))
   (C:attribute put-T 'inline)
   (C:define-func get-T
	T
	'((x ptr-t))
	'(C:return (C:* (type-cast (C:type* T) x))))
   (C:attribute get-T 'inline)))





"
;----------------------------- non-local exits --------------------------------

*NLEXIT-HEADER*	macro that prepares a loop for non local exit
*NLEXIT-FOOTER*	macro that define variables so as to allow further exit
*NLEXIT-TEST*	macro to test for non-local exit
*NLEXIT-GO*	macro to do a non-local exit
	all these take one argument as unique name/prefix of the structure
	being defined for non-local exit.
*NLEXIT-localonly* is defined iff the non-locality is emulated and needs
		functions to return to a local scope whenever they issued
		such an exit, and to skip things that an actual non-local
		exit would skip.


ifdef({HAS-SETJUMP},{

(define *NLEXIT-HEADER*},{
	DeclareVariable($1*exit-buf,jmp-buf)
	if(!setjmp($1*exit-buf))
	BEGIN
})
(define *NLEXIT-FOOTER*},{
	END
})
(define *NLEXIT-TEST*},{
	BEGIN ; END
})
(define *NLEXIT-GO*},{longjmp($1*exit-buf,-1);})

},{

(define *NLEXIT-HEADER*},{
	DeclareVariable($1*exit-p,boolean)
	BEGIN
	  $1*exit-p = FALSE;
})
(define *NLEXIT-FOOTER*},{
	END
	$1*exit-label:
})
(define *NLEXIT-TEST*},{
	BEGIN if ($1*exit-p) goto $1*exit-label ; END
})
(define *NLEXIT-GO*},{$1*exit-p = TRUE;})

(define *NLEXIT-localonly*})

})
"






; --------------------------- Structures --------------------------------

;(C:define-struct 'API-Signature
;   '((Magic-Number 'uint32)
;     (Object-Name  (array 20 byte))
;     (Version	   (array 8 byte))))

"
struc API-Header {
   int32 TotalLength ;		/* total length of the file */
   int32 EntryPoint ;		/* address of object to return */
   int32 Offset	;		/* offset where to load it */
   int32 HeaderSize ;		/* size of header fields in file */
   int32 ExpandedSize ;		/* size when expanded to memory */
   int32 *** ;			/* fill in */
   int32 CheckSum ;		/* checksum */
   int32 LongCheckSum ;		/* long checksum */
})
"
