(provide 'map)

(map C:include
  '(stdio unistd sys/types sys/stat fcntl sys/mman))

(C:define 'MEM-BASE '(C:typecast 'caddr-t #x80000000))	; 2GB
(C:define 'MEM_SIZE (* 1000 1024 1024))			; 0.99 GB


;;; Translate the below from C...

void reserve_swap(void) {
  caddr_t N;
  int fd;
  off_t off;
  caddr_t p;
  int err;

  N = tmpnam(NULL);
  DBG( errprintf("Swapping Memory on file %s ", N) );

  fd = open(FOO_FILE, O_RDWR); /* file was created by tmpnam() */
  if(fd == -1) {
     perror("\nopening swap file");
     abort(); /* will remove temporary files */
  }

  DBG( errprintf("with file descriptor %d.\n", fd) );
  off = lseek(fd, MEM_SIZE, SEEK_SET);
  DBG( errprintf("Setting file size to %ld.\n", off) );

  if(off!=MEM_SIZE) {
     errprintf("Could not set swap file size to %ld.\n", off);
     abort();
  }

  p = mmap(MEM_BASE,
	   MEM_SIZE,
	   PROT_EXEC|PROT_READ|PROT_WRITE,
	   MAP_FILE|MAP_FIXED|MAP_SHARED,
	   fd,
	   0);
  if(p!=MEM_BASE) {
     errprintf("Could not map swap file at 0x%08X!\n", MEM_BASE);
     abort();
  }
  DBG( errprintf("Mapped swap file at 0x%08X.\n", MEM_BASE) );

  DBG( return );

  err = unlink(N);
  if(err) {
     perror("removing swap file");
     abort();
  }
  DBG( errprintf("Removed file %s so no one else will mess it up.\n", N) );
}


void main(void)
{
  int fd;
  caddr_t p;


  printf("Hello, World !\n");
  reserve_swap();
  sleep(100000);
}
