;--------------- version.scm: read the version number for TUNES --------------

(provide 'version)
(require 'debug)

(define TUNES:MAJOR-VERSION #f)
(define TUNES:MINOR-VERSION #f)
(define TUNES:PATCH-LEVEL #f)
(define TUNES:INTERNAL-REVISION #f)

(let*
  ((parse-equal
      (let*
         ((eq-line (read-string))
          (eqpos (search-string eq-line "="))
          (lhs (substring eq-line 0 eqpos))
	  (rhs (substring eq-line (1+ eqpos) (string-length eq-line)))
	  (sym (string->symbol (string-append "TUNES:" lhs)))
	  (val (string->number rhs)))
	 (eval `(define ,sym ,val)))))
  (call-with-input-file "../../../version"
     (lambda ()
        (parse-equal)
        (parse-equal)
        (parse-equal)
        (parse-equal))))

(define TUNES:VERSION
   (format "~d.~d.~d.~d"
      TUNES:MAJOR-VERSION
      TUNES:MINOR-VERSION
      TUNES:PATCH-LEVEL
      TUNES:INTERNAL-REVISION))

(debug-display (format "We are Tunes ~a!\n" TUNES:VERSION))
